/*
    iprig - Remote radio via IP
    Copyright (C) 2007  Ladislav Vaiz <ok1zia@nagano.cz>

    This program is free software; you can redistribute it and/or                                                        
    modify it under the terms of the GNU General Public License                                                          
    version 2 as published by the Free Software Foundation.

*/

#include "header.h"

struct sdump *sdump;

struct sdump *init_sdump(void){
	sdump=mem_alloc(sizeof(struct sdump));
	bzero(sdump, sizeof(struct sdump));

    setvbuf(stdout, NULL, _IONBF, 0);
    
    sdump_open(0, "/dev/tts/0");
    sdump->colors[0]=31;
    
    sdump_open(1, "/dev/tts/1");
    sdump->colors[1]=32;
    
    
    
	return sdump;
}

int sdump_open(int idx, char *filename){
	char errbuf[1030];
	struct termios tio;
	

	sdump->fd[idx]=open(filename, O_RDONLY | O_SYNC | O_NONBLOCK | O_NOCTTY);
	if (sdump->fd[idx] < 0){
		error("error opening file %s - %s\n", filename, STRERR(errno));
		return -1;
	}
	dbg("sdump opened, fd=%d\n", sdump->fd[idx]);
    
	if (fcntl(sdump->fd[idx], F_SETFL, O_NONBLOCK)) {
		error("error setting nonblock %s\n", STRERR(errno));
        return -1;
    }
    
	if (tcgetattr(sdump->fd[idx],&tio)){
		error("tcgetattr failed %s\n", STRERR(errno));
	}else{
        tio.c_cflag=B19200|CS8|CLOCAL|CREAD;
        tio.c_iflag=INPCK;
        tio.c_lflag=0;
        tio.c_oflag=0;
        tio.c_cc[VMIN]=1;
        tio.c_cc[VTIME]=5;
        
        if (tcsetattr(sdump->fd[idx],TCSANOW,&tio)){
            error("tcsetattr failed %s\n", STRERR(errno));
            return -1;
        }
    }

    set_handlers(sdump->fd[idx], sdump_read_handler, NULL, NULL, (void*)idx);
    
	return sdump->fd[idx];
}

void sdump_read_handler(void *xxx){
    int ret, idx, i;
	char errbuf[1030];

    idx=(int)xxx;

    ret=read(sdump->fd[idx], sdump->rdbuf, MAXRDBUF);
    /*dbg("read=%d\n", ret);*/
    if (ret<=0) {
        error("error reading fd %d - %s\n", idx, STRERR(errno));
        terminate = 1;
        return;
        
    }

    printf("%c[1;%dm", 27, sdump->colors[idx]);
    for (i=0;i<ret;i++){
        printf("%02x ", (unsigned)sdump->rdbuf[i]);
    }
    printf("%c[0m", 27);
    
}
